//兼容代码
if (!Object.entries) {
    Object.entries = function (obj) {
        var ownProps = Object.keys(obj),
            i = ownProps.length,
            resArray = new Array(i); // preallocate the Array
        while (i--)
            resArray[i] = [ownProps[i], obj[ownProps[i]]];

        return resArray;
    };
}

if (!String.prototype.repeat) {
    String.prototype.repeat = function(n) {
        return (new Array(n + 1)).join(this);
    }
}

if(!Object.assign) {
    Object.assign = function(target) {
        'use strict';
        if(target === undefined || target === null) {
            throw new TypeError('Cannot convert undefined or null to object');
        }

        var output = Object(target);
        for(var index = 1; index < arguments.length; index++) {
            var source = arguments[index];
            if(source !== undefined && source !== null) {
                for(var nextKey in source) {
                    if(source.hasOwnProperty(nextKey)) {
                        output[nextKey] = source[nextKey];
                    }
                }
            }
        }
        return output;
    };
}

if (!Object.prototype.forEach) {

    Object.prototype.forEach = function forEach(callback, thisArg) {

        var T, k;

        if (this == null) {
            throw new TypeError("this is null or not defined");
        }
        var O = Object(this);
        var len = O.length >>> 0;
        if (typeof callback !== "function") {
            throw new TypeError(callback + " is not a function");
        }
        if (arguments.length > 1) {
            T = thisArg;
        }
        k = 0;

        while (k < len) {

            var kValue;
            if (k in O) {

                kValue = O[k];
                callback.call(T, kValue, k, O);
            }
            k++;
        }
    };
}


//功能函数
function getOS()
{
    var agent = navigator.userAgent.toLowerCase();
    var iOS = /iPad|iPhone|iPod/.test(navigator.userAgent) && !window.MSStream;
    var MAC = /macintosh|mac os x/i.test(navigator.userAgent) && !window.MSStream;
    var android = /Android/.test(navigator.userAgent) && !window.MSStream;

    if (agent.indexOf("win32") >= 0 || agent.indexOf("wow32") >= 0)
    {
        return "windows"; // 此处根据需求调整
    }
    if (agent.indexOf("win64") >= 0 || agent.indexOf("wow64") >= 0)
    {
        return "windows"; // 此处根据需求调整
    }
    if (iOS)
    {
        return "iphone";
    }
    if (MAC)
    {
        return "mac";
    }
    if (android)
    {
        return "android";
    }
    return "unknown";
}

function fullScreen() {
    if (getOS() === 'android') {
        var element = document.documentElement;
        if (element.requestFullscreen) {
            element.requestFullscreen();
        } else if (element.msRequestFullscreen) {
            element.msRequestFullscreen();
        } else if (element.mozRequestFullScreen) {
            element.mozRequestFullScreen();
        } else if (element.webkitRequestFullscreen) {
            element.webkitRequestFullscreen();
        }
        // lockScreenOrientation('lock');
    }
}

//退出全屏
function exitFullscreen() {
    if (getOS() === 'android') {
        if (document.exitFullscreen) {
            document.exitFullscreen();
        } else if (document.msExitFullscreen) {
            document.msExitFullscreen();
        } else if (document.mozCancelFullScreen) {
            document.mozCancelFullScreen();
        } else if (document.webkitExitFullscreen) {
            document.webkitExitFullscreen();
        }
        // lockScreenOrientation('unlock');
    }
}

function resize_content(){
    var w = document.documentElement.clientWidth || document.body.clientWidth;
    var h = document.documentElement.clientHeight || document.body.clientHeight;
    if(w > h){
        document.querySelector('#content-wrap').classList.add('landscape')
    }else{
        document.querySelector('#content-wrap').classList.remove('landscape')
    }
}

function ajax_get(url, callback)
{
    var xmlhttp;
    if (window.XMLHttpRequest)
    {// code for IE7+, Firefox, Chrome, Opera, Safari
        xmlhttp=new XMLHttpRequest();
    }
    else
    {// code for IE6, IE5
        xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
    }
    xmlhttp.onreadystatechange=function()
    {
        if (xmlhttp.readyState === 4 && xmlhttp.status === 200)
        {
            if (callback) {
                callback(xmlhttp.responseText);
            }
        }
    }
    xmlhttp.open("GET",url,true);
    xmlhttp.send();
}

function toggleShow(name) {
    document.querySelector(name).removeEventListener('click', close_dropdown);
    document.querySelector(name).removeEventListener('touchstart', close_dropdown);
    document.querySelector(name).classList.toggle("show");
    document.querySelector(name).addEventListener('click', close_dropdown);
    document.querySelector(name).addEventListener('touchstart', close_dropdown);
}

// Close the dropdown menu if the user clicks outside of it
function close_dropdown(event) {
    if(event.target.matches('.dropdown-content')){
        event.target.classList.remove('show');
    } else if(event.target.matches('.li') || event.target.parentElement.matches('.li')){
        var target = event.target;
        if(target.parentElement.matches('.li')){
            target = target.parentElement;
        }
        if(!target.classList.contains('check')) {
            target.parentElement.querySelector('.check').classList.remove('check');
            target.classList.add('check');
        }
    }
}

function next_step(name) {
    fullScreen();
    document.querySelector(name).classList.add('current');
    document.documentElement.scrollTop = 0;
}

function back_step(name){
    exitFullscreen();
    document.querySelector(name).classList.remove('current');
    document.documentElement.scrollTop = 0;
    window.swiper.forEach(function(item){
       item.slideTo(0);
    });
}

function next_page(name, dropdown, target) {
    var page = document.querySelector(name);
    if(!page.classList.contains('current')) {
        var txt = target.querySelector('.name').innerText;
        document.querySelector(name).parentElement.querySelector('.page.current').classList.remove('current');
        document.querySelector(name).parentElement.parentElement.querySelector('.dropbtn .name').innerText = txt;
        page.classList.add('current');

        var video_btn = target.parentElement.parentElement.parentElement.querySelector('.action-bar');
        video_btn.querySelector('.video.active').classList.remove('active');
        video_btn.querySelector('.video.video-'+name.split('-')[4]).classList.add('active');

        document.documentElement.scrollTop = 0;
        window.swiper.forEach(function(item){
            item.slideTo(0);
        });
    }
    if (dropdown) {
        document.querySelector(dropdown).classList.remove('show');
    }
}

function hidden_bar(target){
    var bar = target.parentElement.parentElement.parentElement.querySelector('.action-bar')
    if(bar){
        bar.classList.toggle('hidden')
    }
    var des = target.parentElement.querySelector('.des')
    if(des){
        des.classList.toggle('hidden');
    }
    target.querySelector('.swiper-wrapper').classList.toggle('bg-big')
    draw_bg_txt();
}

function show_more(event){
    event.stopPropagation();
    var parent = event.target.parentElement.parentElement.parentElement.parentElement.parentElement;
    parent.classList.add('show_more')
    if(event.target.parentElement.parentElement.parentElement.parentElement.classList.contains('max-w-500')){
        event.target.parentElement.parentElement.parentElement.parentElement.style.height = '70%';
    }
}

function hidden_more(event){
    event.stopPropagation();
    if(event.target.matches('.current') && event.target.parentElement.classList.contains('show_more')) {
        event.target.parentElement.classList.remove('show_more')
    }
    if(event.target.matches('.hidden-btn') && event.target.parentElement.parentElement.parentElement.parentElement.classList.contains('show_more')) {
        event.target.parentElement.parentElement.parentElement.parentElement.classList.remove('show_more')
        event.target.parentElement.parentElement.parentElement.style.height = 'unset';
    }
}

function lockScreenOrientation (action) {
    if (action === 'lock') {
        if (window.screen.lockOrientation) {
            window.screen.lockOrientation("portrait-primary");
        } else if (window.screen.mozLockOrientation) {
            window.screen.mozLockOrientation("portrait-primary");
        } else if (window.screen.msLockOrientation) {
            window.screen.msLockOrientation("portrait-primary");
        } else if (window.screen.orientation && window.screen.orientation.lock) {
            window.screen.orientation.lock("portrait-primary");
        }
    } else {
        if (window.screen.unlockOrientation) {
            window.screen.unlockOrientation();
        } else if (window.screen.mozUnlockOrientation) {
            window.screen.mozUnlockOrientation();
        } else if (window.screen.msUnlockOrientation) {
            window.screen.msUnlockOrientation();
        } else if (window.screen.orientation && window.screen.orientation.unlock) {
            window.screen.orientation.unlock();
        }
    }
}

function draw_bg_txt(){
    var list = document.querySelectorAll('.bg_txt_wrap');
    if(list) {
        list.forEach(function (item) {
            item.querySelectorAll('.show-name-box').forEach(function (item2) {
                item2.style.marginLeft = '-' + (item2.offsetWidth / 2) + 'px'
                item2.style.marginTop = '-' + (item2.offsetHeight / 2) + 'px'
                if(item2.childElementCount === 1){
                    if(item2.firstElementChild.offsetWidth - item2.offsetWidth > 2){
                        item2.firstElementChild.classList.add('long-txt')
                    }else{
                        item2.firstElementChild.classList.remove('long-txt')
                    }
                }
            })
        });
    }
}

function stop_scale(){
    document.addEventListener('touchstart', function(event) {
        if (event.touches.length > 1) {
            event.preventDefault();
        }
    });
    document.addEventListener('touchend', function(event) {
        var now = (new Date()).getTime();
        if (now - window.lastTouchEnd <= 300) {
            event.preventDefault();
        }
        window.lastTouchEnd = now;
    }, false);

    // 阻止双指放大
    document.addEventListener('gesturestart', function(event) {
        event.preventDefault();
    });
}

function init_swiper(config){
    var default_config = {
        pagination: {
            el: '.swiper-pagination',
        },
        loop: false,
        on: {
            progress: function(e, progress){
                if(window.os !== 'windows' && window.os !== 'mac') {
                    var des = e.el.parentElement.querySelector('.des')
                    var start = 1 / e.wrapperEl.childElementCount * e.activeIndex
                    var height = des.getBoundingClientRect().height * -1
                    des.style.bottom = (height * (Math.abs(progress - start) / (1 / e.wrapperEl.childElementCount))) + 'px'
                }
            },
            slideChange: function (e) {
                if(window.os !== 'windows' && window.os !== 'mac') {
                    var des = e.el.parentElement.querySelector('.des')
                    des.querySelector('.current').classList.remove('current')
                    des.querySelector('.des-' + (e.activeIndex + 1)).classList.add('current')
                    des.style.bottom = '0'
                }
            },
            transitionEnd: function (e) {
                if(window.os !== 'windows' && window.os !== 'mac') {
                    var des = e.el.parentElement.querySelector('.des')
                    des.querySelector('.current').classList.remove('current')
                    des.querySelector('.des-' + (e.activeIndex + 1)).classList.add('current')
                    des.style.bottom = '0'
                }
            }
        }
    };

    if(config){
        default_config = Object.assign(default_config, config)
    }

    window.swiper = new Swiper('.swiper-container', default_config);
}

function resize_listener(){
    if (window.os === 'android' || window.os === 'iphone'){
        resize_content();
    }
    if(window.timer){
        clearTimeout(window.timer);
    }
    window.timer = setTimeout(function(){
        draw_bg_txt();
    }, 100)
}

//初始化、监听
window.onload = function() {
    window.os = getOS();
    // window.os = 'mac';
    window.timer = null;
    if (window.os === 'iphone') {
        window.lastTouchEnd = 0;
        stop_scale();
    }

    document.querySelector('#content-wrap').classList.add(window.os);

    resize_listener();

    var resizeEvt = 'orientationchange' in window ? 'orientationchange' : 'resize'
    window.addEventListener(resizeEvt, resize_listener, false);

    var url = './' + window.os + '.html';
    ajax_get(url, function (response) {
        document.querySelector('#content-wrap').innerHTML=response;
        var swiper = document.querySelector('.swiper-container');
        if(swiper){
            var config = {}
            if(window.os === 'windows' || window.os === 'mac'){
                config.navigation = {
                    nextEl: '.swiper-button-next',
                    prevEl: '.swiper-button-prev'
                };
            }
            init_swiper(config);
        }
        ajax_get('lang.json', function(response){
            var lang = JSON.parse(response);
            var txt_list = document.querySelectorAll('[data-string_id]');
            var OS_list = {
                'android': '<b>'+lang['help_select_device_device_system_android']+'</b>',
                'iphone': '<b>'+lang['help_select_device_device_system_ios']+'</b>',
                'mac': '<b>'+lang['help_select_device_device_system_mac']+'</b>',
                'windows': '<b>'+lang['help_select_device_device_system_win']+'</b>'
            };
            txt_list.forEach(function(item){
                var id_string = item.getAttribute('data-string_id');
                if(id_string && lang.hasOwnProperty(id_string)){
                    var string = lang[id_string];
                    if(id_string === 'help_cast_finalcast_hint_content_android_screen_cast_2'){
                        var temp = string.split("*");
                        string = '<table>';
                        for(var i = 1; i < temp.length; i+=2){
                            string += '<tr>';
                            string += '<td>*' + temp[i].trim() + '</td>';
                            if(i + 1 < temp.length -1){
                                string += '<td>*' + temp[i+1].trim() + '</td>';
                            }else{
                                string += '<td></td>';
                            }
                            string += '</tr>';
                        }
                        string += '</table>';
                    }
                    var string_replace_key = item.getAttribute('data-string_replace_key');
                    if(string_replace_key){
                        string_replace_key = string_replace_key.split(",");
                        var string_replace_type = item.getAttribute('data-string_replace_type').split(",");
                        var string_replace_value = item.getAttribute('data-string_replace_value');
                        if(string_replace_value) string_replace_value = string_replace_value.split(",");
                        string_replace_key.forEach(function(key, n){
                            var value = '';
                            switch (string_replace_type[n]){
                                case 'O':
                                    value = OS_list[window.os];
                                    break;
                                case 'S':
                                    value = '<b>'+lang[string_replace_value[n]]+'</b>';
                                    break;
                                case 'I':
                                    value = '<i class="iconfont">&#'+string_replace_value[n]+';</i>';
                                    break;
                                case 'U':
                                    value = '<a target="_blank" href="'+lang[string_replace_value[n]]+'">'+lang[string_replace_value[n]]+'</a>';
                                    break;
                            }
                            string = string.replace('[%'+key+']', value);
                        });
                    }
                    if(string.indexOf('[') > -1){
                        console.log(item)
                        console.log(id_string, string)
                    }
                    var string_pre = item.getAttribute('data-string_pre');
                    if(string_pre){
                        string = string_pre + ' ' + string;
                    }
                    item.innerHTML = string;
                }else{
                    console.log('not find ' + id_string)
                }
            });
            var url_list = document.querySelectorAll('[data-video]');
            url_list.forEach(function(item){
                var video_id = item.getAttribute('data-video');
                if(video_id && lang.hasOwnProperty('video_list') && lang.video_list.hasOwnProperty(video_id)){
                    item.href= 'https://www.youtube.com/watch?v='+lang.video_list[video_id];
                }
            });
            setTimeout(function(){
                draw_bg_txt();
                document.querySelector('.loading').style.opacity = '0';
                setTimeout(function(){
                    document.querySelector('.loading').style.display = 'none';
                }, 1000);
            },500);
        });
    });
}